/***************************************************************************
                          histogramdlg.h  -  description
                             -------------------
    begin                : Tue Nov 11 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HISTOGRAMDLG_H
#define HISTOGRAMDLG_H

#include <qdialog.h>
#include <qpixmap.h>
#include <qscrollview.h>
#include <apaintdoc.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class QTabWidget;
class QWidget;

/*HISTOGRAM 1*/

class Histogram: public QScrollView {
 Q_OBJECT
public:
  Histogram(QWidget *parent, const char *name);
  ~Histogram(){};

  void setColorData(QRgb *ctab, int *hNumTab, int *hColTab);
  
protected:

   void refresh(QPainter *p, QRect refRect);
   void drawContents(QPainter *p, int clipx, int clipy, int clipw, int cliph);
   void viewportResizeEvent(QResizeEvent *e);
   void recalcData();
private:

  QRgb colTab[256];
  int  histogramCol[256];
  int  histogramNum[256];
  int allPix, numCol;     
  bool dataLoaded;
  int wsize, hsize, hei;
};

/*HISTOGRAM 2*/

class Histogram2: public QScrollView {
public:
  Histogram2(QWidget *parent, const char *name);
 ~Histogram2();

  void setData(ApaintImage &img, double sx, double sy);
  void setScale(double sx, double sy);
protected:

  void refresh(QPainter *p, QRect refRect);
  void drawContents(QPainter *p, int clipx, int clipy, int clipw, int cliph);
  void viewportResizeEvent(QResizeEvent *e);
  void recalcData();
  
private:

  typedef  struct
  {
   int col[256] ;
  } ColumnColors;
  
  ApaintImage himg;
  ColumnColors *imgLine;
  bool dataLoaded;
  int hei, wid;
  double scaleX, scaleY;
  
};

/*HISTOGRAM 3*/

class Histogram3: public QScrollView {
public:
  Histogram3(QWidget *parent, const char *name);
 ~Histogram3();

  void setData(ApaintImage &img, double sx, double sy);
  void setScale(double sx, double sy);
protected:

  void refresh(QPainter *p, QRect refRect);
  void drawContents(QPainter *p, int clipx, int clipy, int clipw, int cliph);
  void viewportResizeEvent(QResizeEvent *e);
  void recalcData();
  
private:

  typedef  struct
  {
   int col[256] ;
  } ColumnColors;
  
  ApaintImage himg;
  ColumnColors *imgLine;
  bool dataLoaded;
  int hei, wid;
  double scaleX, scaleY;
  
};

/* HISTOGRAM DIALOG*/

class HistogramDlg : public QDialog  {
  Q_OBJECT
public: 
	HistogramDlg(QWidget* parent, const char* name, ApaintDoc *docp);
	~HistogramDlg();

  void startDlg();
  
public slots:    
  void closeDlg();
  void refreshDlg();
  void layerChanged(Layer *layer);
  void zoomChanged(double scaleX, double scaleY);
  
protected:

  void refreshHistogram();
  void closeEvent(QCloseEvent *e);

   QTabWidget* tabHistogram;
   QWidget* tab;
   QPushButton* btnRefresh;
   QPushButton* btnClose;
   QVBoxLayout* HistogramDialogLayout;
   QHBoxLayout* Layout2;
    
private:

  ApaintDoc *doc;  
  Histogram *histo;
  Histogram2 *histo2;
  Histogram3 *histo3;
  bool isOn;
  double scaleX, scaleY;
};

#endif
