/***************************************************************************
                          brushtool.h  -  description
                             -------------------
    begin                : pet feb 28 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BRUSHTOOL_H
#define BRUSHTOOL_H

#include <toolbase.h>
#include <qpainter.h>
#include <math.h>
#include <qpointarray.h>

class DrawInRepeat;
class ApaintDoc;
class QVBoxLayout;
class QCheckBox;
class ApaintBrushList;
class Layer;
class CommonProp;

class BrushToolProp: public QWidget {
   Q_OBJECT
public:
   BrushToolProp(QWidget *parent, const char *name);
   ~BrushToolProp();
   
   QCheckBox *cbStamp;
   
signals:
  void stampModeToggle(bool toggle);
   
private:  
  QVBoxLayout  *vbox;  
};
    
class BrushTool : public ToolBase  {
  Q_OBJECT
public: 
	BrushTool(DrawInRepeat *drawp, ToolType type, PropObject *propObj, ApaintDoc *docp);
	~BrushTool();

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void begin();
 virtual void end();
 virtual void showCommonProp(bool enable);

signals:
 void colorTableChanged(Layer *selLayer);
 
public slots:
 void enableStampMode(bool enable);

private slots:
 void enableAspectDraw(bool enable);
 
private:

 void drawBrush(QPainter *pi, int x, int y, bool final);

 bool drawStarted;
 bool stampMode;
 int lastx, lasty, brushx, brushy, brushWid, brushHei;
 ButtonState btnPressed;
 DrawInRepeat *draw;
 ApaintDoc *doc;
 BrushToolProp *brushProp;
 ApaintBrushList *bList;
 QRect pos, oldPos;
 CommonProp *cProp;
};

#endif
