/***************************************************************************
                          toolFreeTransform.h  -  description
                             -------------------
    begin                : Wed Sep 8 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSFORM_FREE_H
#define TRANSFORM_FREE_H

#include <toolbase.h>
#include <qdialog.h>
#include "qpoint.h"
#include "dialog_ui_freeTransform.h"

class ApaintDoc;
class Layer;

class FreeTransformDialog: public FreeTransformDialogUI {
  Q_OBJECT
public:
  FreeTransformDialog(QWidget *parent, const char *name);
  ~FreeTransformDialog();
  
signals:
  void okClicked();
  void closeSig();

protected:
  void closeEvent(QCloseEvent *e);
    
};

class FreeTransformTool : public ToolBase  {
  Q_OBJECT
public:
  FreeTransformTool(ToolType type, ApaintDoc *docp, FreeTransformDialog *fdlgp, PropObject *propObj);
  ~FreeTransformTool();

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void afterRefresh(QPainter *p);
 void end();
 void begin();

private slots:
  //It does forward transformation from rect to selected quad.
  void doTransform();
  void layerChangedSlot(Layer *layer);
   
private:
 void drawPoints(QPainter *p);
 int getSelPoint(int x, int y);
 QRect getRefreshArea();
 void resetTool();
 
 QPoint qPts[4];
 int ptSelected;
 ApaintDoc *doc;
 FreeTransformDialog *fdlg;
 bool toolIsActive;
};

#endif


