/***************************************************************************
                          linetool.cpp  -  description
                             -------------------
    begin                : Wed Feb 26 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "toolLine.h"
#include "apaintdrawrepeat.h"
#include "apaintUtil.h"
#include "apaintconfig.h"
#include "apaint.h"

#include <qapplication.h>
#include <qwidget.h>
#include <stdio.h>   
#include <qlayout.h>
#include <qtooltip.h>
#include <cmath>

extern char *getCommonPNG(const char *pixName);

QBrush *polyBrush;

void MeasureToolProp::moveLeftClicked()
{
 apaint->menuActivated(MOVE_LEFT);
}

void MeasureToolProp::moveRightClicked()
{
 apaint->menuActivated(MOVE_RIGHT);
}

void MeasureToolProp::moveUpClicked()
{
 apaint->menuActivated(MOVE_UP);
}

void MeasureToolProp::moveDownClicked()
{
 apaint->menuActivated(MOVE_DOWN);
}

void MeasureToolProp::tiltLeftClicked()
{
 apaint->menuActivated(TILT_RIGHT);
}

void MeasureToolProp::tiltRightClicked()
{
 apaint->menuActivated(TILT_LEFT);
}

void MeasureToolProp::tiltUpClicked()
{
 apaint->menuActivated(TILT_UP);
}

void MeasureToolProp::tiltDownClicked()
{
 apaint->menuActivated(TILT_DOWN);
}

void MeasureToolProp::splitHorizontalClicked()
{
 apaint->menuActivated(SPLIT_X);
}

void MeasureToolProp::splitVerticalClicked()
{
 apaint->menuActivated(SPLIT_Y);
}

void MeasureToolProp::joinHorizontalClicked()
{
 apaint->menuActivated(JOIN_X);
}

void MeasureToolProp::joinVerticalClicked()
{
 apaint->menuActivated(JOIN_Y);
}

MeasureToolProp::MeasureToolProp(QWidget *parent, const char *name) : QWidget(parent, name)
{
// QGridLayout *gbox = new QGridLayout(this, 3,2);
 QGridLayout *gbox = new QGridLayout(this, 5,4);
 gbox->addWidget(new QLabel("point", this), 0, 0);
 gbox->addWidget(new QLabel("cm", this), 1, 0);
 gbox->addWidget(new QLabel("in", this), 2, 0);
 point = new QLabel(this);
 cm = new QLabel(this);
 in = new QLabel(this);

 lbSizeX = new QLabel(this);
 lbSizeY = new QLabel(this);
 lbValue = new QLabel(this);
 lbSizeX->setText("X:");
 lbSizeY->setText("Y:");
// maybe possible alternative 
// lbSizeX->setPixmap(QPixmap(getCommonPNG("object-flip-horizontal")));
// lbSizeY->setPixmap(QPixmap(getCommonPNG("object-flip-vertical")));

 lbValue->setText(ApaintConfig::getText(788));
 lbSizeX->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
 lbSizeY->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
 lbValue->setAlignment(Qt::AlignRight | Qt::AlignVCenter);

 sbSizeX = new QSpinBox(this);
 sbSizeY = new QSpinBox(this);
 sbValue = new QSpinBox(this);
 sbSizeX->setMaxValue(9999);
 sbSizeY->setMaxValue(9999);
 sbValue->setMaxValue(9999);

 gbox->addWidget(point, 0, 1);
 gbox->addWidget(cm, 1, 1);
 gbox->addWidget(in, 2, 1);

 gbox->addWidget(lbSizeX, 0, 2);
 gbox->addWidget(lbSizeY, 1, 2);
 gbox->addWidget(lbValue, 2, 2);
 gbox->addMultiCellWidget(sbSizeX, 0, 0, 3, 4);
 gbox->addMultiCellWidget(sbSizeY, 1, 1, 3, 4);
 gbox->addMultiCellWidget(sbValue, 2, 2, 3, 4);

 moveLeft =  new QPushButton(QPixmap(getCommonPNG("left")), NULL, this);
 moveRight = new QPushButton(QPixmap(getCommonPNG("right")), NULL, this);
 moveUp =    new QPushButton(QPixmap(getCommonPNG("up")), NULL, this);
 moveDown =  new QPushButton(QPixmap(getCommonPNG("down")), NULL, this);
 
 tiltLeft =  new QPushButton(QPixmap(getCommonPNG("tiltRight")), NULL, this);
 tiltRight = new QPushButton(QPixmap(getCommonPNG("tiltLeft")), NULL, this);
 tiltUp =    new QPushButton(QPixmap(getCommonPNG("tiltDown")), NULL, this);
 tiltDown =  new QPushButton(QPixmap(getCommonPNG("tiltUp")), NULL, this);

 splitHorizontal  = new QPushButton(QPixmap(getCommonPNG("splitHorizontal")), NULL, this);
 splitVertical    = new QPushButton(QPixmap(getCommonPNG("splitVertical")), NULL, this);
 joinHorizontal   = new QPushButton(QPixmap(getCommonPNG("joinHorizontal")), NULL, this);
 joinVertical     = new QPushButton(QPixmap(getCommonPNG("joinVertical")), NULL, this);

 QToolTip::add(moveLeft,  ApaintConfig::getText(780) + " " + ApaintConfig::getText(774));
 QToolTip::add(moveRight, ApaintConfig::getText(780) + " " + ApaintConfig::getText(775));
 QToolTip::add(moveUp,    ApaintConfig::getText(780) + " " + ApaintConfig::getText(776));
 QToolTip::add(moveDown,  ApaintConfig::getText(780) + " " + ApaintConfig::getText(777));

 QToolTip::add(tiltLeft,  ApaintConfig::getText(773) + " " + ApaintConfig::getText(774));
 QToolTip::add(tiltRight, ApaintConfig::getText(773) + " " + ApaintConfig::getText(775));
 QToolTip::add(tiltUp,    ApaintConfig::getText(773) + " " + ApaintConfig::getText(777));
 QToolTip::add(tiltDown,  ApaintConfig::getText(773) + " " + ApaintConfig::getText(776));

 QToolTip::add(splitHorizontal, ApaintConfig::getText(778) + " " + ApaintConfig::getText(46));
 QToolTip::add(splitVertical,   ApaintConfig::getText(778) + " " + ApaintConfig::getText(47));
 QToolTip::add(joinHorizontal,  ApaintConfig::getText(779) + " " + ApaintConfig::getText(46));
 QToolTip::add(joinVertical,    ApaintConfig::getText(779) + " " + ApaintConfig::getText(47));

 connect(moveLeft,  SIGNAL(clicked()), this, SLOT(moveLeftClicked()));
 connect(moveRight, SIGNAL(clicked()), this, SLOT(moveRightClicked()));
 connect(moveUp,    SIGNAL(clicked()), this, SLOT(moveUpClicked()));
 connect(moveDown,  SIGNAL(clicked()), this, SLOT(moveDownClicked()));

 connect(tiltLeft,  SIGNAL(clicked()), this, SLOT(tiltLeftClicked()));
 connect(tiltRight, SIGNAL(clicked()), this, SLOT(tiltRightClicked()));
 connect(tiltUp,    SIGNAL(clicked()), this, SLOT(tiltUpClicked()));
 connect(tiltDown,  SIGNAL(clicked()), this, SLOT(tiltDownClicked()));

 connect(splitHorizontal, SIGNAL(clicked()), this, SLOT(splitHorizontalClicked()));
 connect(splitVertical,   SIGNAL(clicked()), this, SLOT(splitVerticalClicked()));
 connect(joinHorizontal,  SIGNAL(clicked()), this, SLOT(joinHorizontalClicked()));
 connect(joinVertical,    SIGNAL(clicked()), this, SLOT(joinVerticalClicked()));

 gbox->addWidget(moveLeft,  3, 0);
 gbox->addWidget(moveRight, 3, 1);
 gbox->addWidget(moveUp,    4, 0);
 gbox->addWidget(moveDown,  4, 1);

 gbox->addWidget(tiltLeft,  3, 3);
 gbox->addWidget(tiltRight, 3, 2);
 gbox->addWidget(tiltUp,    4, 2);
 gbox->addWidget(tiltDown,  4, 3);

 gbox->addWidget(splitHorizontal, 5, 3);
 gbox->addWidget(joinHorizontal,  5, 4);
 gbox->addWidget(splitVertical,   3, 4);
 gbox->addWidget(joinVertical,    4, 4);
 
 cbVarColors = new QCheckBox(this);
 cbVarSize = new QCheckBox(this);
 cbGradient = new QCheckBox(this);
 cbVarColors->setPixmap(QPixmap(getCommonPNG("convert-indexed")));
 cbVarSize->setPixmap(QPixmap(getCommonPNG("transform-scale")));
 cbGradient->setPixmap(QPixmap(getCommonPNG("gradient-bilinear")));
 gbox->addWidget(cbVarColors, 5, 0);
 gbox->addWidget(cbVarSize, 5, 1);
 gbox->addWidget(cbGradient, 5, 2);
// gbox->addMultiCellWidget(cbVarSize, 5, 5, 1, 2);
}

void MeasureToolProp::measureChanged(int dx, int dy, double xdpi, double ydpi)
{
 if ((dx==0) || (dy==0))
  point->setText(QString().setNum((int)sqrt(dx*dx+dy*dy)+1));
 else
  point->setText(QString("%1").arg(sqrt(dx*dx+dy*dy)+1, 0, 'f', 1));

 if ((xdpi>0) && (ydpi>0))
  {
   double x = dx / xdpi;
   double y = dy / ydpi;
   double din = sqrt(x*x+y*y)*1000;
   double dcm = din * 2.54;
   cm->setText(QString("%1").arg(dcm, 0, 'f', 2));
   in->setText(QString("%1").arg(din, 0, 'f', 2));
  }
}

void MeasureToolProp::drawMeasure(ApaintDoc *d, QPainter *p, int x1, int y1, int x2, int y2, double zoomX, double zoomY)
{
 static ApaintDoc *doc = 0;
 static QPainter *pc = 0;

 if (d == 0)
  {
   if (doc != 0)
    {
     doc->refreshLayer();
     return;
    }
  }
 else
  doc = d;

 if (p != 0)
  pc = p;

 if (pc != 0)
  {
   /* same as select tool */
   pc->setRasterOp(XorROP);
   QPen pen(QColor(128,128,0));
   pen.setWidth(2);
   pc->setPen(pen);
   pc->drawLine((x1+0.5)*zoomX+10, (y1+0.5)*zoomY, (x1+0.5)*zoomX-10, (y1+0.5)*zoomY);
   pc->drawLine((x2+0.5)*zoomX+10, (y2+0.5)*zoomY, (x2+0.5)*zoomX-10, (y2+0.5)*zoomY);
   pc->drawLine((x1+0.5)*zoomX, (y1+0.5)*zoomY+10, (x1+0.5)*zoomX, (y1+0.5)*zoomY-10);
   pc->drawLine((x2+0.5)*zoomX, (y2+0.5)*zoomY+10, (x2+0.5)*zoomX, (y2+0.5)*zoomY-10);
   pc->drawLine((x1+0.5)*zoomX, (y1+0.5)*zoomY, (x2+0.5)*zoomX, (y2+0.5)*zoomY);
  }
}

namespace
{
 bool reject = false;
}

void MeasureToolProp::hideEvent(QHideEvent*)
{
 reject = true;
 drawMeasure(0, 0, 0, 0, 0, 0, 0, 0);
}

void LineTool::afterRefresh(QPainter *pc)
{
 if (reject)
  return;

 if (ltyp==measure)
  mProp->drawMeasure(doc, pc, sx, sy, lx, ly, zoomX, zoomY);
 reject = false;
}

LineTool::LineTool(DrawInRepeat *drawp, ApaintDoc *adoc, ToolType type, LineType typ, PropObject *propObj)
: ToolBase((typ == measure ? SelectionTool : type), propObj)
{
 cur=QCursor(ArrowCursor);
 drawStarted = false;
 drawType = NormalDraw;
 noBrush = QBrush(Qt::NoBrush);
 solidBrush = QBrush(Qt::SolidPattern);
 solidBrush.setColor(white);
 selBrush = noBrush;
 setToolChangeType(NoChange);

 if (typ==normalLine)
  setToggleBtn(QPixmap(getCommonPNG("draw-line")), tr("Line Tool"));
 else
  if (typ==rbLine)
   {
    setToggleBtn(QPixmap(getCommonPNG("draw-polyline")), QPixmap(getCommonPNG("draw-polyline-filled")));
    setToolChangeType(FillChangeType);
   }
  else
   {
    setToggleBtn(QPixmap(getCommonPNG("measure")), tr("Measure Tool"));
    mProp = (MeasureToolProp*) propObj->pWidget();
   }
 doc = adoc;

 ltyp=typ;

 if (propObj)
  setUsepWidget(true);
 Q_CHECK_PTR(drawp);
 draw = drawp;
 lineWid = 1;
}

LineTool::~LineTool()
{
}

QPixmap LineTool::getToolPix()
{
  if (drawType == FillDraw)
   return toolPix2;

  return toolPix;
}

void LineTool::drawPointer(QPainter *p, int x, int y)
{
 if (ltyp != measure)
  ToolBase::drawPointer(p, x, y);
 else
  {
   QWidget *widget = (QWidget*) (p->device());

   if (&(widget->cursor()) != &cur)
    widget->setCursor(cur);
  }
}

bool LineTool::doChangeTool(ToolChangeType chgType)
{
 if ((chgType == FillChangeType) && (getChangeType() == FillChangeType))
  {
   if (drawType == NormalDraw)
    {
     drawType = FillDraw;
     selBrush = solidBrush;
    }
   else
    {
     drawType = NormalDraw;
     selBrush = noBrush;
    }
   return true;
  }
  return false;
}

void LineTool::showCommonProp(bool enable)
{
  CommonProp *cProp = CommonProp::getObject();
  cProp->setAspectDrawProp(enable && (ltyp != measure));
  cProp->setThickLinesProp(enable && (ltyp != measure));
}

void LineTool::mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi)
{
 int x=(int)(e->x()/zoomX);
 int y=(int)(e->y()/zoomY);

 lineWid = (pi->pen().width()+2)/2;
 if (drawStarted && ltyp==normalLine) return;
 btnPressed = e->button();

 if (ltyp == measure)
  mProp->drawMeasure(doc, pc, sx, sy, lx, ly, zoomX, zoomY);

 if (btnPressed == MidButton)
  {
   if (drawType == FillDraw)
    {
     pi->setRasterOp(XorROP);
     pi->setBrush(*polygonBrush);
     QPen pen = pi->pen();
     int lineWidth = pen.width();
     pen.setWidth(0);
     pi->setPen(pen);
     draw->drawClosedPolygon(pi, polygon, pointsNum, false, false, false);
     pen.setWidth(lineWidth);
     pi->setPen(pen);
     pi->setRasterOp(CopyROP);
     draw->drawClosedPolygon(pi, polygon, pointsNum, true, true, true);
    }
   drawStarted = false;
   return;
  }

 if ((ltyp == rbLine) && drawStarted && (drawType == NormalDraw))
  {
   if (btnPressed==RightButton)
    {
      drawStarted=false;
      draw->clearRect(lineWid, sx, sy, lx, ly);
      return;
    }
   else
    if (btnPressed == LeftButton)
     endLineDraw(pi, true);
  }

 if (drawType == FillDraw)
  {
   if (btnPressed == RightButton)
    {
     if (!drawStarted)
      return;

     pi->setRasterOp(XorROP);
     pi->setBrush(*polygonBrush);
     QPen pen = pi->pen();
     int lineWidth = pen.width();
     pen.setWidth(0);
     pi->setPen(pen);
     draw->drawClosedPolygon(pi, polygon, pointsNum, false, false, false);
     pi->setRasterOp(CopyROP);
     pen.setWidth(lineWidth);
     pi->setPen(pen);
     draw->drawClosedPolygon(pi, polygon, pointsNum-1, true, true, true);
     drawStarted = false;

     return;
    }

    if (!drawStarted)
     {
      if (selBrush == noBrush)
       polygonBrush = &selBrush;
      else
       polygonBrush = &solidBrush;

      polyBrush = polygonBrush;
      pointsNum = 2;
      polygon.resize(2);
      polygon[0] = polygon[1] = QPoint(x,y);
     }
    else
     if (btnPressed == LeftButton)
      {
       polygon.resize(++pointsNum);
       polygon[pointsNum-1] = QPoint(x,y);
      }
  }

 drawStarted=true;
 sx=lx=x;
 sy=ly=y;
 if (drawType == NormalDraw)
  {
   pi->setRasterOp(XorROP);
   draw->drawLine(pi, sx, sy, lx, ly, false, false, false);
  }
}

void LineTool::mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi)
{
	static bool firstTime;
	int lineWidth = pi->pen().width();

	if (!drawStarted) return;

	int x=(int)(e->x()/zoomX);
	int y=(int)(e->y()/zoomY);
	pi->setRasterOp(XorROP);

	if ((drawType == NormalDraw) || (pointsNum == 2))
	{
		if (drawType == FillDraw)
		{
			QPen pen = pi->pen();
			pen.setWidth(0);
			pi->setPen(pen);
			firstTime = true;
			polygon[pointsNum-1] = QPoint(x,y);
		}

		if (ltyp == measure) {
			mProp->drawMeasure(doc, pc, sx, sy, lx, ly, zoomX, zoomY);
			mProp->drawMeasure(doc, pc, sx, sy, x, y, zoomX, zoomY);
			mProp->measureChanged(x-sx,y-sy, doc->getLayer()->imageBuf.xdpi(), doc->getLayer()->imageBuf.ydpi());
		} else {
			draw->drawLine(pi, sx, sy, lx, ly, false, false, false);
			draw->drawLine(pi, sx, sy, x, y, true, (btnPressed == LeftButton), false);
		}
	}
	else
	{
		QPen pen = pi->pen();
		pen.setWidth(0);
		pi->setPen(pen);
		pi->setBrush(*polygonBrush);
		draw->drawClosedPolygon(pi, polygon, pointsNum, false, false, false);

		if (!firstTime)
		{
			firstTime = false;
			draw->drawLine(pi, sx, sy, lx, ly,  false, false, false);
		}

	   polygon[pointsNum-1] = QPoint(x,y);
	   draw->drawClosedPolygon(pi, polygon, pointsNum, true, (btnPressed == LeftButton), false);
	  }

	 lx=x;
	 ly=y;
   QPen pen = pi->pen();
   pen.setWidth(lineWidth);
   pi->setPen(pen);
}

void LineTool::endLineDraw(QPainter *pi, bool useFg)
{
 pi->setRasterOp(CopyROP);

 if (drawType == NormalDraw)
 draw->drawLine(pi, sx, sy, lx, ly, true, useFg, true);
}

void LineTool::mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi)
{
 if (ltyp==rbLine) return;  
 if (!drawStarted) return;

 drawStarted=false;
 if (ltyp!=measure)
  endLineDraw(pi, (btnPressed == LeftButton));
}

void LineTool::begin()
{
  drawStarted = false;
  sx = sy = lx = ly = 0;
}

void LineTool::end()
{
 ToolBase::end();
 if (ltyp==rbLine)
  {
   if (drawStarted)
     draw->clearRect(lineWid, sx, sy, lx, ly);
   drawStarted=false;
  } 
}

StraightLineTool::StraightLineTool(DrawInRepeat *drawp, ApaintDoc *adoc, PropObject *propObj)
: ToolBase(DrawTool, propObj)
{
 straightLine = false;
 cur=QCursor(ArrowCursor);
 drawStarted = false;
 drawType = NormalDraw;
 noBrush = QBrush(Qt::NoBrush);
 solidBrush = QBrush(Qt::SolidPattern);
 solidBrush.setColor(white);
 selBrush = noBrush;
 setToolChangeType(NoChange);
 setToggleBtn(QPixmap(getCommonPNG("draw-line-back")), QPixmap(getCommonPNG("draw-straight-line")));
 doc = adoc;

 if (propObj)
  setUsepWidget(true);

 Q_CHECK_PTR(drawp);
 draw = drawp;
 lineWid = 1;
 activeTool = false;
}

StraightLineTool::~StraightLineTool()
{
}

QPixmap StraightLineTool::getToolPix()
{
  return straightLine ? toolPix2 : toolPix;
}

bool StraightLineTool::doChangeTool(ToolChangeType chgType)
{
  if (!activeTool) return false;

  straightLine = !straightLine;

  return true;
}

void StraightLineTool::showCommonProp(bool enable)
{
  CommonProp *cProp = CommonProp::getObject();
  cProp->setAspectDrawProp(enable);
  cProp->setThickLinesProp(enable);
}

void StraightLineTool::mousePressed(QMouseEvent *e, QPainter *, QPainter *pi)
{
 if (drawStarted) return;

 btnPressed = e->button();

 if ((btnPressed != LeftButton) && (btnPressed != RightButton)) return;

 int x=(int)(e->x()/zoomX);
 int y=(int)(e->y()/zoomY);

 lineWid = (pi->pen().width()+2)/2;
 drawStarted=true;
 sx=lx=x;
 sy=ly=y;
 pi->setRasterOp(CopyROP);
 QPen p = pi->pen();
// p.setCapStyle(straightLine ? Qt::FlatCap : Qt::RoundCap);
 p.setCapStyle(Qt::FlatCap);
 pi->setPen(p);
 draw->drawLine(pi, sx, sy, lx, ly, true, btnPressed == LeftButton, false);
}

void StraightLineTool::mouseMoved(QMouseEvent *e, QPainter *, QPainter *pi)
{
 if ((btnPressed != LeftButton) && (btnPressed != RightButton)) return;

 int lineWidth = pi->pen().width();

 if (!drawStarted) return;

 int x=(int)(e->x()/zoomX);
 int y=(int)(e->y()/zoomY);
 int nx = x, ny = y;
 int min, d, d2;

 if (straightLine)
 {
 if (abs(x-sx) < abs(y-sy))
 {
  nx = sx;
  ny = y;
  min = abs(x-sx);
 }
 else
 {
  nx = x;
  ny = sy;
  min = abs(y-sy);
 }

 min *= min;
 d = (x+y-sx-sy)/2;
 d2 = (sx-x+d)*(sx-x+d) + (sy-y+d)*(sy-y+d);

 if (d2 < min)
 {
  nx = sx + d;
  ny = sy + d;
  min = d2;
 }

 d = (x-y-sx+sy)/2;
 d2 = (sx-x+d)*(sx-x+d) + (sy-y-d)*(sy-y-d);

 if (d2 < min)
 {
  nx = sx + d;
  ny = sy - d;
 }
 }
 pi->setRasterOp(NorROP);
 QPen p = pi->pen();
// p.setCapStyle(straightLine ? Qt::FlatCap : Qt::RoundCap);
 p.setCapStyle(Qt::FlatCap);
 pi->setPen(p);
 draw->drawLine(pi, sx, sy, lx, ly, false, false, false);
 pi->setRasterOp(CopyROP);
 draw->drawLine(pi, sx, sy, nx, ny, true, (btnPressed == LeftButton), false);

 lx=nx;
 ly=ny;
 QPen pen = pi->pen();
 pen.setWidth(lineWidth);
 pi->setPen(pen);
}

void StraightLineTool::endLineDraw(QPainter *pi, bool useFg)
{
 pi->setRasterOp(CopyROP);
 QPen p = pi->pen();
// p.setCapStyle(straightLine ? Qt::FlatCap : Qt::RoundCap);
 p.setCapStyle(Qt::FlatCap);
 pi->setPen(p);
 draw->drawLine(pi, sx, sy, lx, ly, true, useFg, true);
}

void StraightLineTool::mouseReleased(QMouseEvent *, QPainter *, QPainter *pi)
{
 if (!drawStarted) return;
 drawStarted=false;
 endLineDraw(pi, (btnPressed == LeftButton));
}

void StraightLineTool::begin()
{
  drawStarted = false;
  sx = sy = lx = ly = 0;
  activeTool = true;
}

void StraightLineTool::end()
{
  activeTool = false;
  ToolBase::end();
}
